///////////////////////////////////////////////////////////
//  GeodeticPosition.h
//  Implementation of the Interface GeodeticPosition
//  Created on:      15-Mar-2012 09:39:16
///////////////////////////////////////////////////////////

#if !defined(EA_B224B471_5BB7_483c_847A_70FF581E4C00__INCLUDED_)
#define EA_B224B471_5BB7_483c_847A_70FF581E4C00__INCLUDED_

#include "Distance.h"
#include "Angle.h"
#include "Geometry.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace geometry
			{
				/**
				 * GeoPosition represent a geographical position, i.e., a position on the earth
				 * using the WS84 model.
				 */
				class GeodeticPosition : public org::omg::tacsit::geometry::Geometry
				{

				public:
					/**
					 * @return the altitude in meters or {@link Double.NAN} if the altitude is
					 * not valid.
					 */
					virtual std::auto_ptr<org::omg::tacsit::geometry::Distance> getAltitude() =0;
					/**
					 * @return the Latitude in radians.
					 */
					virtual std::auto_ptr<org::omg::tacsit::geometry::Angle> getLatitude() =0;
					/**
					 * @return the Longitude in radians.
					 */
					virtual std::auto_ptr<org::omg::tacsit::geometry::Angle> getLongitude() =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace geometry
			{
				class GeodeticPosition;
			}
		}
	}
}
#endif // !defined(EA_B224B471_5BB7_483c_847A_70FF581E4C00__INCLUDED_)
