///////////////////////////////////////////////////////////
//  Geometry.h
//  Implementation of the Interface Geometry
//  Created on:      15-Mar-2012 09:39:16
///////////////////////////////////////////////////////////

#if !defined(EA_BD093F8F_9DCD_479f_B070_B0BE58B3B73D__INCLUDED_)
#define EA_BD093F8F_9DCD_479f_B070_B0BE58B3B73D__INCLUDED_

#include "GeodeticPosition.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace geometry
			{
				/**
				 * @author jtruss
				 */
				class Geometry
				{

				public:
					/**
					 * If the Geometry is has an altitude component this method will ignore it
					 * and only test against the ground projection of the shape.
					 * 
					 * @return whether the given point is contained within the shape.
					 */
					virtual bool contains(std::auto_ptr<org::omg::tacsit::geometry::GeodeticPosition> point) =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace geometry
			{
				class Geometry;
			}
		}
	}
}
#endif // !defined(EA_BD093F8F_9DCD_479f_B070_B0BE58B3B73D__INCLUDED_)
