///////////////////////////////////////////////////////////
//  GeometryQuery.h
//  Implementation of the Interface GeometryQuery
//  Created on:      15-Mar-2012 09:39:16
///////////////////////////////////////////////////////////

#if !defined(EA_29C1611E_5555_42d9_A750_4276C3838DD5__INCLUDED_)
#define EA_29C1611E_5555_42d9_A750_4276C3838DD5__INCLUDED_

#include "Geometry.h"
#include "EntityQuery.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace query
			{
				/**
				 * The EntityTypeQuery is used to determine whether or not a given Entity has a
				 * geometrical relationship with a particular Entity.
				 */
				class GeometryQuery : public org::omg::tacsit::query::EntityQuery
				{

				public:
					/**
					 * Returns the Geometry against which an Entity will be evaluated.
					 * 
					 * @return 
					 */
					virtual std::auto_ptr<org::omg::tacsit::geometry::Geometry> getGeometry() =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace query
			{
				class GeometryQuery;
			}
		}
	}
}
#endif // !defined(EA_29C1611E_5555_42d9_A750_4276C3838DD5__INCLUDED_)
