///////////////////////////////////////////////////////////
//  Projection.h
//  Implementation of the Interface Projection
//  Created on:      15-Mar-2012 09:41:28
///////////////////////////////////////////////////////////

#if !defined(EA_20B489F6_773F_4dfa_8FC0_336841AD3086__INCLUDED_)
#define EA_20B489F6_773F_4dfa_8FC0_336841AD3086__INCLUDED_

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				/**
				 * A projection is a method of displaying entities the surface of the earth on a
				 * TacSit Viewport (i.e., a Map Projection).
				 * 
				 * For the purpose of the Tacsit Controller interface projections are only
				 * needed to refer to by name.
				 * 
				 * Each Toolkit may support whatever projections it supports, this is a method
				 * for the users to get a list of supported projections without having to
				 * specify any details of how they are implemented.
				 */
				class Projection
				{

				public:
					/**
					 * @return 
					 */
					virtual std::string getName() =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				class Projection;
			}
		}
	}
}
#endif // !defined(EA_20B489F6_773F_4dfa_8FC0_336841AD3086__INCLUDED_)
