///////////////////////////////////////////////////////////
//  QueryManager.h
//  Implementation of the Interface QueryManager
//  Created on:      15-Mar-2012 09:39:17
///////////////////////////////////////////////////////////

#if !defined(EA_87A6F6B3_1175_4541_B300_7BBE4088E3E9__INCLUDED_)
#define EA_87A6F6B3_1175_4541_B300_7BBE4088E3E9__INCLUDED_

#include "Entity.h"
#include "EntityQuery.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace query
			{
				/**
				 * The QueryManager supports the execution of queries for entities against the
				 * TacSit Controller.
				 * 
				 * Queries submitted through the QueryManager are transient in nature; that is,
				 * the results of a query represent the state of the TacSit Controller at the
				 * time the Query was executed. Query results will not be maintained by the
				 * QueryManager as the state of the TacSit Controller changes. Since the
				 * QueryManager treats the Query objects as stateless, the same Query may be
				 * re-used for any number of subsequent submissions.
				 * 
				 * In the case where a null query is passed to the QueryManager, the QueryManager
				 * is to return all Entities in the QueryManager.
				 */
				class QueryManager
				{

				public:
					/**
					 * Returns the set of all Entities that satisfy the criteria expressed in
					 * the given EntityQuery.
					 * 
					 * @return 
					 */
					virtual std::auto_ptr<org::omg::tacsit::controller::Entity> submitEntityQuery(std::auto_ptr<org::omg::tacsit::query::EntityQuery> query) =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace query
			{
				class QueryManager;
			}
		}
	}
}
#endif // !defined(EA_87A6F6B3_1175_4541_B300_7BBE4088E3E9__INCLUDED_)
