///////////////////////////////////////////////////////////
//  Rectangle.h
//  Implementation of the Interface Rectangle
//  Created on:      15-Mar-2012 09:39:17
///////////////////////////////////////////////////////////

#if !defined(EA_92361221_4194_43eb_975A_38CBA2A4AAB0__INCLUDED_)
#define EA_92361221_4194_43eb_975A_38CBA2A4AAB0__INCLUDED_

#include "Distance.h"
#include "Angle.h"
#include "Centered.h"
#include "Geometry.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace geometry
			{
				class Rectangle : public org::omg::tacsit::geometry::Centered, public org::omg::tacsit::geometry::Geometry
				{

				public:
					/**
					 * @return the height of the rectangular shape in meters
					 */
					virtual std::auto_ptr<org::omg::tacsit::geometry::Distance> getHeight() =0;
					/**
					 * @return the azimuth of the y axis of the rectangle shape, where zero is
					 * north in radians.
					 */
					virtual std::auto_ptr<org::omg::tacsit::geometry::Angle> getOrientation() =0;
					/**
					 * @return the width of the rectangle shape in meters
					 */
					virtual std::auto_ptr<org::omg::tacsit::geometry::Distance> getWidth() =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace geometry
			{
				class Rectangle;
			}
		}
	}
}
#endif // !defined(EA_92361221_4194_43eb_975A_38CBA2A4AAB0__INCLUDED_)
