///////////////////////////////////////////////////////////
//  SelectionEvent.h
//  Implementation of the Class SelectionEvent
//  Created on:      15-Mar-2012 09:41:28
///////////////////////////////////////////////////////////

#if !defined(EA_88D543D7_5196_4b29_B3E5_D10D348CDEB9__INCLUDED_)
#define EA_88D543D7_5196_4b29_B3E5_D10D348CDEB9__INCLUDED_

#include "Entity.h"
#include "SelectionType.h"
#include "SelectionManager.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				/**
				 * SelectionEvent is the type of event that is passed to a SelectionListener
				 * each time there is a change in one of the selections of a SelectionManager.
				 */
				class SelectionEvent
				{

				public:
					SelectionEvent(std::vector<std::auto_ptr<org::omg::tacsit::controller::Entity>> entities, std::auto_ptr<org::omg::tacsit::controller::SelectionManager> source, std::auto_ptr<org::omg::tacsit::controller::SelectionType> type);
					virtual std::vector<std::auto_ptr<org::omg::tacsit::controller::Entity>> getEntities() =0;
					/**
					 * Returns the type of selection that has changed.
					 * 
					 * @return 
					 */
					virtual SelectionType getSelectionType() =0;
					/**
					 * Returns the SelectionManager in which the selection change occurred.
					 * 
					 * @return 
					 */
					virtual std::auto_ptr<org::omg::tacsit::controller::SelectionManager> getSource() =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				class SelectionEvent;
			}
		}
	}
}
#endif // !defined(EA_88D543D7_5196_4b29_B3E5_D10D348CDEB9__INCLUDED_)
