///////////////////////////////////////////////////////////
//  SelectionListener.h
//  Implementation of the Interface SelectionListener
//  Created on:      15-Mar-2012 09:41:28
///////////////////////////////////////////////////////////

#if !defined(EA_9D13D864_1DFC_4421_AC99_1D6C7349B257__INCLUDED_)
#define EA_9D13D864_1DFC_4421_AC99_1D6C7349B257__INCLUDED_

#include "SelectionEvent.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				/**
				 * SelectionListener is the type of object that is notified by a
				 * SelectionManager where it is registered in case of a change in one of the
				 * selections of that SelectionManager.
				 */
				class SelectionListener
				{

				public:
					/**
					 * This method is called by a SelectionManager when this SelectionListener
					 * is registered for selection changes for that SelectionManager. The
					 * details of which selection changed and which elements are still in the
					 * selection can be obtained through the given SelectionEvent.
					 */
					virtual void selectionChanged(std::auto_ptr<org::omg::tacsit::controller::SelectionEvent> event) =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				class SelectionListener;
			}
		}
	}
}
#endif // !defined(EA_9D13D864_1DFC_4421_AC99_1D6C7349B257__INCLUDED_)
