///////////////////////////////////////////////////////////
//  SelectionMethodology.h
//  Implementation of the Class SelectionMethodology
//  Created on:      15-Mar-2012 09:41:29
///////////////////////////////////////////////////////////

#if !defined(EA_344C69B7_5E6B_4218_A96B_94F2EBF31A6C__INCLUDED_)
#define EA_344C69B7_5E6B_4218_A96B_94F2EBF31A6C__INCLUDED_

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				/**
				 * SelectionMethodology determines the scope of the SelectionManagers of the
				 * TacsitController.
				 */
				enum SelectionMethodology
				{
					/**
					 * This instance indicates that each Viewport of the TacsitController has its own
					 * SelectionManager.
					 * 
					 * Therefore the selection on one viewport does not depend on the selection on
					 * another viewport.
					 */
					ViewportDependent,
					/**
					 * This instance indicates that all Viewports of the TacsitController have a
					 * common SelectionManager.
					 * 
					 * Therefore the selection on one viewport depends on the selection on another
					 * viewport: the selections on multiple viewports are identical.
					 */
					ViewportIndependent
				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				enum SelectionMethodology;
			}
		}
	}
}
#endif // !defined(EA_344C69B7_5E6B_4218_A96B_94F2EBF31A6C__INCLUDED_)
