///////////////////////////////////////////////////////////
//  ViewportChangeEvent.h
//  Implementation of the Class ViewportChangeEvent
//  Created on:      15-Mar-2012 09:41:30
///////////////////////////////////////////////////////////

#if !defined(EA_DD5F7847_F266_46fc_AAD4_6F92EC803214__INCLUDED_)
#define EA_DD5F7847_F266_46fc_AAD4_6F92EC803214__INCLUDED_

#include "Viewport.h"
#include "ViewEyeProperties.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				/**
				 * ViewportChangeEvent is the type of event that is passed to a
				 * ViewportChangeListener each time the Viewport changes.
				 * 
				 * Through the ViewportChangeEvent it is possible to know which Viewport has
				 * been changed and details of the change.
				 * 
				 * If there are properties other than the view eye that the client is interested
				 * in, they can query the associated Viewport Object contained in the event
				 * available in the getSource() method.
				 */
				class ViewportChangeEvent
				{

				public:
					ViewportChangeEvent(std::auto_ptr<org::omg::tacsit::controller::Viewport> viewport, std::auto_ptr<org::omg::tacsit::controller::ViewEyeProperties> viewEyeProperties);
					/**
					 * Returns the Viewport that has changed
					 * 
					 * @return 
					 */
					virtual std::auto_ptr<org::omg::tacsit::controller::Viewport> getSource() =0;
					/**
					 * Returns a copy of the ViewEyeProperties of the Viewport that has changed.
					 * 
					 * @return 
					 */
					virtual std::auto_ptr<org::omg::tacsit::controller::ViewEyeProperties> getViewEyeProperties() =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				class ViewportChangeEvent;
			}
		}
	}
}
#endif // !defined(EA_DD5F7847_F266_46fc_AAD4_6F92EC803214__INCLUDED_)
