///////////////////////////////////////////////////////////
//  ViewportChangeListener.h
//  Implementation of the Interface ViewportChangeListener
//  Created on:      15-Mar-2012 09:41:30
///////////////////////////////////////////////////////////

#if !defined(EA_172DB13C_1B3E_4fc1_BF44_1EEB629D2A27__INCLUDED_)
#define EA_172DB13C_1B3E_4fc1_BF44_1EEB629D2A27__INCLUDED_

#include "ViewportChangeEvent.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				/**
				 * ViewportChangeListener is the type of object that is notified about a
				 * Viewport that it is registered for notification of changes
				 */
				class ViewportChangeListener
				{

				public:
					/**
					 * This method should be called by the Viewport where this
					 * ViewportChangeListener is registered in case a Viewport is changed.
					 * 
					 * The details of the change can be obtained through the given
					 * ViewportChangeEvent.
					 */
					virtual void viewportChanged(std::auto_ptr<org::omg::tacsit::controller::ViewportChangeEvent> event) =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				class ViewportChangeListener;
			}
		}
	}
}
#endif // !defined(EA_172DB13C_1B3E_4fc1_BF44_1EEB629D2A27__INCLUDED_)
