///////////////////////////////////////////////////////////
//  ViewportManagerEvent.h
//  Implementation of the Interface ViewportManagerEvent
//  Created on:      15-Mar-2012 09:41:30
///////////////////////////////////////////////////////////

#if !defined(EA_4B7DB23A_326B_4586_85A0_D6707FBDDAA9__INCLUDED_)
#define EA_4B7DB23A_326B_4586_85A0_D6707FBDDAA9__INCLUDED_

#include "ViewportManager.h"
#include "Viewport.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				/**
				 * ViewportManagerEvent is the type of event that is passed to a
				 * ViewportManagerListener each time there is a Viewport is added or removed
				 * from the ViewportManager.
				 * 
				 * Through the ViewportManagerEvent it is possible to know which Viewport has
				 * been added to which ViewportManager
				 */
				class ViewportManagerEvent
				{

				public:
					/**
					 * Returns the ViewportManager to which a Viewport has been added or
					 * removed.
					 * 
					 * @return 
					 */
					virtual std::auto_ptr<org::omg::tacsit::controller::ViewportManager> getSource() =0;
					/**
					 * Returns the viewport that has been added or removed by this event.
					 * 
					 * @return 
					 */
					virtual std::auto_ptr<org::omg::tacsit::controller::Viewport> getViewport() =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				class ViewportManagerEvent;
			}
		}
	}
}
#endif // !defined(EA_4B7DB23A_326B_4586_85A0_D6707FBDDAA9__INCLUDED_)
