///////////////////////////////////////////////////////////
//  ViewportManagerListener.h
//  Implementation of the Interface ViewportManagerListener
//  Created on:      15-Mar-2012 09:41:31
///////////////////////////////////////////////////////////

#if !defined(EA_24716BE7_7E89_433f_99D0_765CD34E897A__INCLUDED_)
#define EA_24716BE7_7E89_433f_99D0_765CD34E897A__INCLUDED_

#include "ViewportManagerEvent.h"

#include <string>
#include <memory>
#include <vector>
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				/**
				 * ViewportManagerListener is the type of object that is notified by a
				 * ViewportManager where it is registered in case a Viewport is added or removed
				 * from that ViewportManager.
				 */
				class ViewportManagerListener
				{

				public:
					/**
					 * This method is called by the ViewportManager where this
					 * ViewportManagerListener is registered in case a Viewport is added.
					 * 
					 * The details of the addition can be obtained through the given
					 * ViewportManagerEvent.
					 */
					virtual void viewportAdded(std::auto_ptr<org::omg::tacsit::controller::ViewportManagerEvent> event) =0;
					/**
					 * This method is called by the ViewportManager where this
					 * ViewportManagerListener is registered in case a Viewport is removed.
					 * 
					 * The details of the removal can be obtained through the given
					 * ViewportManagerEvent.
					 */
					virtual void viewportRemoved(std::auto_ptr<org::omg::tacsit::controller::ViewportManagerEvent> event) =0;

				};

			}

		}

	}

}
#else
namespace org
{
	namespace omg
	{
		namespace tacsit
		{
			namespace controller
			{
				class ViewportManagerListener;
			}
		}
	}
}
#endif // !defined(EA_24716BE7_7E89_433f_99D0_765CD34E897A__INCLUDED_)
